/* VMConsoleOutputStream.java -- 
   Copyright (C) 2005 Free Software Foundation

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package com.mysaifu.jvm.io;

import java.io.InputStream;
import java.io.IOException;
import java.nio.ByteBuffer;

/**
 * コンソールの入力ストリーム。
 * この入力ストリームから返されるデータはシステムプロパティ
 * file.encoding の内容にしたがって変換される。
 */
public class VMConsoleInputStream extends InputStream {
	/**
	 * 内部バッファ
	 * エンコード形式はUTF-16LEとなっている。
	 * （サイズは必ず偶数バイト）
	 */
	private byte[] nativeData = new byte[128];
	
	/**
	 * データ読み込み用ByteBuffer
	 */
	private ByteBuffer buffer;
	
	public VMConsoleInputStream() {
		// ByteBufferとして取り扱う
		this.buffer = ByteBuffer.wrap(nativeData);
		
		// 初期状態ではバッファは空
		this.buffer.limit(0);
	}
	
	/**
	 * コンソールウインドウからバッファにデータを読み込む
	 */
	private native int readNative(byte[] nativeData);
	
	public int read() throws IOException {
		if (fill() < 0) {
			return -1;
		}
		return this.buffer.get();
	}
	
	public int read(byte[] b, int off, int len) throws IOException {
		if (fill() < 0) {
			return -1;
		}
		// バッファにコピーするサイズを計算する
		int datalen = available();
		int copylen = (len < datalen) ? len : datalen;
		this.buffer.get(b, off, copylen);
		return copylen;
	}
	
	public int available() throws IOException {
		// バッファ内の有効要素数を返す
		return this.buffer.remaining();
	}
	
	/**
	 * 内部バッファにデータがある状態にする
	 *
	 * @return	バッファに格納されたデータのバイト数
	 *          データが取得できなかった場合は -1
	 */
	private int fill() throws IOException {
		if (available() > 0) {
			return available();
		}
		// 内部バッファが空なので、ネイティブコンソールから読み込む
		int limit = readNative(this.nativeData);
		if (limit < 0) {
			return -1;
		}
		// システムのエンコーディングによって動作を変更する
		String encoding = System.getProperty("file.encoding");
		if ("UTF-16LE".equals(encoding)) {
			// 変換が不要な場合は、バッファの状態を設定しなおす
			// ポジション=0
			// リミット=読み込んだバイト数
			this.buffer.position(0);
			this.buffer.limit(limit);
		} else {
			// システムのデフォルトエンコードにあわせて変換する
			String str = new String(this.nativeData, 0, limit, "UTF-16LE");
			byte[] data = str.getBytes(encoding);
			
			// バッファを再構築する
			this.buffer = ByteBuffer.wrap(data);
		}
		return available();
	}
}
